diff --git a/src/test/kerberos/t/001_auth.pl b/src/test/kerberos/t/001_auth.pl
index 34562045cb..a5c1858d3a 100644
--- a/src/test/kerberos/t/001_auth.pl
+++ b/src/test/kerberos/t/001_auth.pl
@@ -16,8 +16,8 @@
 
 use strict;
 use warnings;
-use TestLib;
-use PostgresNode;
+use Postgres::Test::Utils;
+use Postgres::Test::Cluster;
 use Test::More;
 use Time::HiRes qw(usleep);
 
@@ -69,15 +69,15 @@ my $host     = 'auth-test-localhost.postgresql.example.com';
 my $hostaddr = '127.0.0.1';
 my $realm    = 'EXAMPLE.COM';
 
-my $krb5_conf   = "${TestLib::tmp_check}/krb5.conf";
-my $kdc_conf    = "${TestLib::tmp_check}/kdc.conf";
-my $krb5_cache  = "${TestLib::tmp_check}/krb5cc";
-my $krb5_log    = "${TestLib::log_path}/krb5libs.log";
-my $kdc_log     = "${TestLib::log_path}/krb5kdc.log";
-my $kdc_port    = PostgresNode::get_free_port();
-my $kdc_datadir = "${TestLib::tmp_check}/krb5kdc";
-my $kdc_pidfile = "${TestLib::tmp_check}/krb5kdc.pid";
-my $keytab      = "${TestLib::tmp_check}/krb5.keytab";
+my $krb5_conf   = "${Postgres::Test::Utils::tmp_check}/krb5.conf";
+my $kdc_conf    = "${Postgres::Test::Utils::tmp_check}/kdc.conf";
+my $krb5_cache  = "${Postgres::Test::Utils::tmp_check}/krb5cc";
+my $krb5_log    = "${Postgres::Test::Utils::log_path}/krb5libs.log";
+my $kdc_log     = "${Postgres::Test::Utils::log_path}/krb5kdc.log";
+my $kdc_port    = Postgres::Test::Cluster::get_free_port();
+my $kdc_datadir = "${Postgres::Test::Utils::tmp_check}/krb5kdc";
+my $kdc_pidfile = "${Postgres::Test::Utils::tmp_check}/krb5kdc.pid";
+my $keytab      = "${Postgres::Test::Utils::tmp_check}/krb5.keytab";
 
 my $dbname      = 'postgres';
 my $username    = 'test1';
@@ -167,7 +167,7 @@ END
 
 note "setting up PostgreSQL instance";
 
-my $node = PostgresNode->new('node');
+my $node = Postgres::Test::Cluster->new('node');
 $node->init;
 $node->append_conf(
 	'postgresql.conf', qq{
diff --git a/src/test/ldap/t/001_auth.pl b/src/test/ldap/t/001_auth.pl
index 1d1282f8dc..4af9da5728 100644
--- a/src/test/ldap/t/001_auth.pl
+++ b/src/test/ldap/t/001_auth.pl
@@ -3,8 +3,8 @@
 
 use strict;
 use warnings;
-use TestLib;
-use PostgresNode;
+use Postgres::Test::Utils;
+use Postgres::Test::Cluster;
 use Test::More;
 
 if ($ENV{with_ldap} eq 'yes')
@@ -51,21 +51,21 @@ elsif ($^O eq 'freebsd')
 
 $ENV{PATH} = "$ldap_bin_dir:$ENV{PATH}" if $ldap_bin_dir;
 
-my $ldap_datadir  = "${TestLib::tmp_check}/openldap-data";
-my $slapd_certs   = "${TestLib::tmp_check}/slapd-certs";
-my $slapd_conf    = "${TestLib::tmp_check}/slapd.conf";
-my $slapd_pidfile = "${TestLib::tmp_check}/slapd.pid";
-my $slapd_logfile = "${TestLib::log_path}/slapd.log";
-my $ldap_conf     = "${TestLib::tmp_check}/ldap.conf";
+my $ldap_datadir  = "${Postgres::Test::Utils::tmp_check}/openldap-data";
+my $slapd_certs   = "${Postgres::Test::Utils::tmp_check}/slapd-certs";
+my $slapd_conf    = "${Postgres::Test::Utils::tmp_check}/slapd.conf";
+my $slapd_pidfile = "${Postgres::Test::Utils::tmp_check}/slapd.pid";
+my $slapd_logfile = "${Postgres::Test::Utils::log_path}/slapd.log";
+my $ldap_conf     = "${Postgres::Test::Utils::tmp_check}/ldap.conf";
 my $ldap_server   = 'localhost';
-my $ldap_port     = PostgresNode::get_free_port();
-my $ldaps_port    = PostgresNode::get_free_port();
+my $ldap_port     = Postgres::Test::Cluster::get_free_port();
+my $ldaps_port    = Postgres::Test::Cluster::get_free_port();
 my $ldap_url      = "ldap://$ldap_server:$ldap_port";
 my $ldaps_url     = "ldaps://$ldap_server:$ldaps_port";
 my $ldap_basedn   = 'dc=example,dc=net';
 my $ldap_rootdn   = 'cn=Manager,dc=example,dc=net';
 my $ldap_rootpw   = 'secret';
-my $ldap_pwfile   = "${TestLib::tmp_check}/ldappassword";
+my $ldap_pwfile   = "${Postgres::Test::Utils::tmp_check}/ldappassword";
 
 note "setting up slapd";
 
@@ -153,7 +153,7 @@ system_or_bail 'ldappasswd', '-x', '-y', $ldap_pwfile, '-s', 'secret2',
 
 note "setting up PostgreSQL instance";
 
-my $node = PostgresNode->new('node');
+my $node = Postgres::Test::Cluster->new('node');
 $node->init;
 $node->append_conf('postgresql.conf', "log_connections = on\n");
 $node->start;
diff --git a/src/test/modules/brin/t/01_workitems.pl b/src/test/modules/brin/t/01_workitems.pl
index ea2e2944a1..fbc0cc57ec 100644
--- a/src/test/modules/brin/t/01_workitems.pl
+++ b/src/test/modules/brin/t/01_workitems.pl
@@ -6,11 +6,11 @@
 use strict;
 use warnings;
 
-use TestLib;
+use Postgres::Test::Utils;
 use Test::More tests => 2;
-use PostgresNode;
+use Postgres::Test::Cluster;
 
-my $node = PostgresNode->new('tango');
+my $node = Postgres::Test::Cluster->new('tango');
 $node->init;
 $node->append_conf('postgresql.conf', 'autovacuum_naptime=1s');
 $node->start;
diff --git a/src/test/modules/commit_ts/t/001_base.pl b/src/test/modules/commit_ts/t/001_base.pl
index 0c504421d4..4be30f1aa3 100644
--- a/src/test/modules/commit_ts/t/001_base.pl
+++ b/src/test/modules/commit_ts/t/001_base.pl
@@ -6,11 +6,11 @@
 use strict;
 use warnings;
 
-use TestLib;
+use Postgres::Test::Utils;
 use Test::More tests => 2;
-use PostgresNode;
+use Postgres::Test::Cluster;
 
-my $node = PostgresNode->new('foxtrot');
+my $node = Postgres::Test::Cluster->new('foxtrot');
 $node->init;
 $node->append_conf('postgresql.conf', 'track_commit_timestamp = on');
 $node->start;
diff --git a/src/test/modules/commit_ts/t/002_standby.pl b/src/test/modules/commit_ts/t/002_standby.pl
index 227eddeda2..3bf712ef52 100644
--- a/src/test/modules/commit_ts/t/002_standby.pl
+++ b/src/test/modules/commit_ts/t/002_standby.pl
@@ -6,12 +6,12 @@
 use strict;
 use warnings;
 
-use TestLib;
+use Postgres::Test::Utils;
 use Test::More tests => 4;
-use PostgresNode;
+use Postgres::Test::Cluster;
 
 my $bkplabel = 'backup';
-my $primary  = PostgresNode->new('primary');
+my $primary  = Postgres::Test::Cluster->new('primary');
 $primary->init(allows_streaming => 1);
 
 $primary->append_conf(
@@ -22,7 +22,7 @@ $primary->append_conf(
 $primary->start;
 $primary->backup($bkplabel);
 
-my $standby = PostgresNode->new('standby');
+my $standby = Postgres::Test::Cluster->new('standby');
 $standby->init_from_backup($primary, $bkplabel, has_streaming => 1);
 $standby->start;
 
diff --git a/src/test/modules/commit_ts/t/003_standby_2.pl b/src/test/modules/commit_ts/t/003_standby_2.pl
index 27c5bfbfb7..c43ac5508f 100644
--- a/src/test/modules/commit_ts/t/003_standby_2.pl
+++ b/src/test/modules/commit_ts/t/003_standby_2.pl
@@ -6,12 +6,12 @@
 use strict;
 use warnings;
 
-use TestLib;
+use Postgres::Test::Utils;
 use Test::More tests => 4;
-use PostgresNode;
+use Postgres::Test::Cluster;
 
 my $bkplabel = 'backup';
-my $primary  = PostgresNode->new('primary');
+my $primary  = Postgres::Test::Cluster->new('primary');
 $primary->init(allows_streaming => 1);
 $primary->append_conf(
 	'postgresql.conf', qq{
@@ -21,7 +21,7 @@ $primary->append_conf(
 $primary->start;
 $primary->backup($bkplabel);
 
-my $standby = PostgresNode->new('standby');
+my $standby = Postgres::Test::Cluster->new('standby');
 $standby->init_from_backup($primary, $bkplabel, has_streaming => 1);
 $standby->start;
 
diff --git a/src/test/modules/commit_ts/t/004_restart.pl b/src/test/modules/commit_ts/t/004_restart.pl
index 5d92c5a2e6..6a46bfc4b9 100644
--- a/src/test/modules/commit_ts/t/004_restart.pl
+++ b/src/test/modules/commit_ts/t/004_restart.pl
@@ -4,11 +4,11 @@
 # Testing of commit timestamps preservation across restarts
 use strict;
 use warnings;
-use PostgresNode;
-use TestLib;
+use Postgres::Test::Cluster;
+use Postgres::Test::Utils;
 use Test::More tests => 16;
 
-my $node_primary = PostgresNode->new('primary');
+my $node_primary = Postgres::Test::Cluster->new('primary');
 $node_primary->init(allows_streaming => 1);
 $node_primary->append_conf('postgresql.conf', 'track_commit_timestamp = on');
 $node_primary->start;
diff --git a/src/test/modules/libpq_pipeline/t/001_libpq_pipeline.pl b/src/test/modules/libpq_pipeline/t/001_libpq_pipeline.pl
index 49f211c827..bf9bc2d833 100644
--- a/src/test/modules/libpq_pipeline/t/001_libpq_pipeline.pl
+++ b/src/test/modules/libpq_pipeline/t/001_libpq_pipeline.pl
@@ -5,11 +5,11 @@ use strict;
 use warnings;
 
 use Config;
-use PostgresNode;
-use TestLib;
+use Postgres::Test::Cluster;
+use Postgres::Test::Utils;
 use Test::More;
 
-my $node = PostgresNode->new('main');
+my $node = Postgres::Test::Cluster->new('main');
 $node->init;
 $node->start;
 
@@ -20,7 +20,7 @@ my ($out, $err) = run_command([ 'libpq_pipeline', 'tests' ]);
 die "oops: $err" unless $err eq '';
 my @tests = split(/\s+/, $out);
 
-mkdir "$TestLib::tmp_check/traces";
+mkdir "$Postgres::Test::Utils::tmp_check/traces";
 
 for my $testname (@tests)
 {
@@ -30,7 +30,7 @@ for my $testname (@tests)
 		  pipeline_abort transaction disallowed_in_pipeline)) > 0;
 
 	# For a bunch of tests, generate a libpq trace file too.
-	my $traceout = "$TestLib::tmp_check/traces/$testname.trace";
+	my $traceout = "$Postgres::Test::Utils::tmp_check/traces/$testname.trace";
 	if ($cmptrace)
 	{
 		push @extraargs, "-t", $traceout;
diff --git a/src/test/modules/ssl_passphrase_callback/t/001_testfunc.pl b/src/test/modules/ssl_passphrase_callback/t/001_testfunc.pl
index 1f28f303f1..ce09a88e24 100644
--- a/src/test/modules/ssl_passphrase_callback/t/001_testfunc.pl
+++ b/src/test/modules/ssl_passphrase_callback/t/001_testfunc.pl
@@ -6,9 +6,9 @@ use warnings;
 
 use File::Copy;
 
-use TestLib;
+use Postgres::Test::Utils;
 use Test::More;
-use PostgresNode;
+use Postgres::Test::Cluster;
 
 unless (($ENV{with_ssl} || "") eq 'openssl')
 {
@@ -20,7 +20,7 @@ my $rot13pass = "SbbOnE1";
 
 # see the Makefile for how the certificate and key have been generated
 
-my $node = PostgresNode->new('main');
+my $node = Postgres::Test::Cluster->new('main');
 $node->init;
 $node->append_conf('postgresql.conf',
 	"ssl_passphrase.passphrase = '$rot13pass'");
@@ -63,7 +63,7 @@ like(
 $node->append_conf('postgresql.conf', "ssl_passphrase.passphrase = 'blurfl'");
 
 # try to start the server again
-my $ret = TestLib::system_log('pg_ctl', '-D', $node->data_dir, '-l',
+my $ret = Postgres::Test::Utils::system_log('pg_ctl', '-D', $node->data_dir, '-l',
 	$node->logfile, 'start');
 
 
diff --git a/src/test/modules/test_misc/t/001_constraint_validation.pl b/src/test/modules/test_misc/t/001_constraint_validation.pl
index 7c1929f805..8f9b54b00a 100644
--- a/src/test/modules/test_misc/t/001_constraint_validation.pl
+++ b/src/test/modules/test_misc/t/001_constraint_validation.pl
@@ -5,12 +5,12 @@
 
 use strict;
 use warnings;
-use PostgresNode;
-use TestLib;
+use Postgres::Test::Cluster;
+use Postgres::Test::Utils;
 use Test::More tests => 42;
 
 # Initialize a test cluster
-my $node = PostgresNode->new('primary');
+my $node = Postgres::Test::Cluster->new('primary');
 $node->init();
 # Turn message level up to DEBUG1 so that we get the messages we want to see
 $node->append_conf('postgresql.conf', 'client_min_messages = DEBUG1');
diff --git a/src/test/modules/test_pg_dump/t/001_base.pl b/src/test/modules/test_pg_dump/t/001_base.pl
index ea7739d725..55ae455108 100644
--- a/src/test/modules/test_pg_dump/t/001_base.pl
+++ b/src/test/modules/test_pg_dump/t/001_base.pl
@@ -5,12 +5,12 @@ use strict;
 use warnings;
 
 use Config;
-use PostgresNode;
-use TestLib;
+use Postgres::Test::Cluster;
+use Postgres::Test::Utils;
 use Test::More;
 
-my $tempdir       = TestLib::tempdir;
-my $tempdir_short = TestLib::tempdir_short;
+my $tempdir       = Postgres::Test::Utils::tempdir;
+my $tempdir_short = Postgres::Test::Utils::tempdir_short;
 
 ###############################################################
 # This structure is based off of the src/bin/pg_dump/t test
@@ -29,7 +29,7 @@ my $tempdir_short = TestLib::tempdir_short;
 # the full command and arguments to run.  Note that this is run
 # using $node->command_ok(), so the port does not need to be
 # specified and is pulled from $PGPORT, which is set by the
-# PostgresNode system.
+# Postgres::Test::Cluster system.
 #
 # restore_cmd is the pg_restore command to run, if any.  Note
 # that this should generally be used when the pg_dump goes to
@@ -713,7 +713,7 @@ my %tests = (
 #########################################
 # Create a PG instance to test actually dumping from
 
-my $node = PostgresNode->new('main');
+my $node = Postgres::Test::Cluster->new('main');
 $node->init;
 $node->start;
 
diff --git a/src/test/perl/Makefile b/src/test/perl/Makefile
index 3d3a95b52f..427ce916ec 100644
--- a/src/test/perl/Makefile
+++ b/src/test/perl/Makefile
@@ -16,20 +16,20 @@ include $(top_builddir)/src/Makefile.global
 ifeq ($(enable_tap_tests),yes)
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/$(subdir)'
+	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test'
 
 install: all installdirs
-	$(INSTALL_DATA) $(srcdir)/TestLib.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/TestLib.pm'
-	$(INSTALL_DATA) $(srcdir)/SimpleTee.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/SimpleTee.pm'
-	$(INSTALL_DATA) $(srcdir)/RecursiveCopy.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/RecursiveCopy.pm'
-	$(INSTALL_DATA) $(srcdir)/PostgresNode.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/PostgresNode.pm'
-	$(INSTALL_DATA) $(srcdir)/PostgresVersion.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/PostgresVersion.pm'
+	$(INSTALL_DATA) $(srcdir)/Postgres/Test/Utils.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/Utils.pm'
+	$(INSTALL_DATA) $(srcdir)/Postgres/Test/SimpleTee.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/SimpleTee.pm'
+	$(INSTALL_DATA) $(srcdir)/Postgres/Test/RecursiveCopy.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/RecursiveCopy.pm'
+	$(INSTALL_DATA) $(srcdir)/Postgres/Test/Cluster.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/Cluster.pm'
+	$(INSTALL_DATA) $(srcdir)/Postgres/Test/PostgresVersion.pm '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/PostgresVersion.pm'
 
 uninstall:
-	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/TestLib.pm'
-	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/SimpleTee.pm'
-	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/RecursiveCopy.pm'
-	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/PostgresNode.pm'
-	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/PostgresVersion.pm'
+	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/Utils.pm'
+	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/SimpleTee.pm'
+	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/RecursiveCopy.pm'
+	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/Cluster.pm'
+	rm -f '$(DESTDIR)$(pgxsdir)/$(subdir)/Postgres/Test/PostgresVersion.pm'
 
 endif
